//
//  DBHelper.swift
//  Alamofire
//
//  Created by Amit satyapanthi on 30/03/19.
//

import Foundation
//import SQLCipher
import FMDB
import SwiftyJSON

class DBHelper{
    
    static let TABLE_CPM_CUSTOMER_DISPATCH = "CPM_Customer_Dispatch"
    static let TABLE_CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS = "CPM_Customer_Dispatch_Product_Details"
    static let TABLE_CPM_CUSTOMER_RECEIVE = "CPM_Customer_Receive"
    static let TABLE_CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS = "CPM_Customer_Receive_Product_Details"
    static let TABLE_CPM_STRICKER = "CPM_Sticker"
    static let TABLE_CPM_STRICKER_Details = "CPM_Sticker_Details"
    static let TABLE_CPM_CUSTOMER_RECEIVE_DAMAGE = "CPM_Customer_Receive_Damage"
    static let TABLE_CPM_CUSTOMER_OPENING_STOCK = "CPM_Customer_Opening_Stock"
    static let TABLE_CPM_CUSTOMER_PENDING_ORDER = "CPM_Customer_Pending_Order"
    static let TABLE_CPM_CUSTOMER_PENDING_DISPATCH = "CPM_Customer_Pending_Dispatch"
    static let TABLE_CPM_DI_DETAILS = "CPM_DI_Details"
    static let TABLE_STATUS_MST = "Status_Mst"
    static let TABLE_PRODUCT_MAIN_GROUP_MST = "Product_Main_Group_Mst"
    static let TABLE_PRODUCT_BUSINESS_GROUP_MST = "Product_Business_Group_Mst"
    static let TABLE_PRD_MST = "PRD_Mst"
    static let TABLE_PRODUCT_SKU_MST = "Product_SKU_Mst"
    static let TABLE_PRODUCT_SKU_CONVERSION = "Product_SKU_Conversion"
    static let TABLE_COUNTRY_MST = "Countries_Mst"
    static let TABLE_POLITICAL_GEOGRAPHY_LEVEL_REGIONAL_MST = "Political_Geography_Level_Regional_Mst"
    static let TABLE_POLITICAL_GEOGRAPHY_LEVEL_COUNTRY_MST = "Political_Geography_Level_Country_Mst"
    static let TABLE_POLITICAL_GEOGRAPHY_DETAILS = "Political_Geography_Details"
    static let TABLE_SYSTEM_CONFIGURATION_MST = "SystemConfiguration_Mst"
    static let TABLE_EMPLOYEE_TYPE_MST = "Employee_Type_Mst"
    static let TABLE_CUSTOMER_TYPE_REGIONAL_MST = "Customer_Type_Regional_Mst"
    static let TABLE_CUSTOMER_TYPE_COUNTRY_MST = "Customer_Type_Country_Mst"
    static let TABLE_PERSON_MST = "Person_Mst"
     static let TABLE_CPM_DAMAGE_TYPE = "CPM_Damage_Type"
    static let TABLE_UOM_MST = "UOM_Mst"
    static let TABLE_MENU_MST = "Menu_Mst"
    static let TABLE_PSKU_BATCH_STOCK = "CPM_PSKU_Batch_Stock"
    static let TABLE_CUSTOMER_PARTNER_MST = "Customer_Partner_Mst"
    static let TABLE_CPM_CUSTOMER_STICKER_DAMAGE = "CPM_Customer_Sticker_Damage"
    static let TABLE_CPM_CUSTOMER_STICKER_DAMAGE_REMOVE = "CPM_Customer_Sticker_Damage_Remove"
    static let TABLE_LOGIN_DETAILS = "LoginDetails"
    static let TABLE_CPM_PALLET_MST = "CPM_Pallet_Mst"
    
    static let TABLE_LAB_STORE = "LAB_Store"
    static let TABLE_LAB_MATERIAL_ALLOCATION = "LAB_Material_Allocation"
    static let TABLE_LAB_MATERIAL_RETURN = "LAB_Material_Return"
    static let TABLE_LAB_CUSTOMER_DISPATCH = "LAB_Customer_Dispatch"
    static let TABLE_LAB_CUSTOMER_DISPATCH_PRODUCT_DETAILS = "LAB_Customer_Dispatch_Product_Details"
    static let TABLE_LAB_DISPOSAL = "LAB_Disposal"
    static let TABLE_LAB_STICKER_DETAILS = "LAB_Sticker_Details"
    static let TABLE_CPM_Customer_Sticker_Scrap = "CPM_Customer_Sticker_Scrap";
    static let TABLE_CPM_Customer_Sticker_Consume = "CPM_Customer_Sticker_Consume";
}

/*class ExportDBChiper{
     
     func checkDatabaseEnciptedorPlain(datbasePath:String,password:String) -> Bool {
          
          var rc: Int32 = 0
          var db: OpaquePointer? = nil
          sqlite3_open(datbasePath, &db)
          if (rc != SQLITE_OK) {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error opening database: \(errmsg)")
               return false
          }
          
          
          
          //rc = sqlite3_(db, password, Int32(password.utf8CString.count))
          
          //rc = sqlite3_key(db, password, Int32(password.utf8CString.count))
          
          if (rc != SQLITE_OK) {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error setting key: \(errmsg)")
                return false
          }
          
           return true
          
          /*var rc: Int32
          var db: OpaquePointer? = nil
          var stmt: OpaquePointer? = nil
          let password: String = "correct horse battery staple"
          rc = sqlite3_open(":memory:", &db)
          if (rc != SQLITE_OK) {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error opening database: \(errmsg)")
               return
          }
          rc = sqlite3_key(db, password, Int32(password.utf8CString.count))
          if (rc != SQLITE_OK) {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error setting key: \(errmsg)")
          }
          rc = sqlite3_prepare(db, "PRAGMA cipher_version;", -1, &stmt, nil)
          if (rc != SQLITE_OK) {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error preparing SQL: \(errmsg)")
          }
          rc = sqlite3_step(stmt)
          if (rc == SQLITE_ROW) {
               NSLog("cipher_version: %s", sqlite3_column_text(stmt, 0))
          } else {
               let errmsg = String(cString: sqlite3_errmsg(db))
               NSLog("Error retrieiving cipher_version: \(errmsg)")
          }
          sqlite3_finalize(stmt)
          sqlite3_close(db)*/
     }
}*/

class JsonInsert{
     
     static func parseJsonCustomer_Partner_Mst(Tourplan_Daily:JSON,database: FMDatabase)->Bool{
          //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
          if(Tourplan_Daily.count > 0){
               do{
                    var k = 0
                    while (k < Tourplan_Daily.count){
                         
                         var chrTran:String = ""
                         if Tourplan_Daily[k]["chrTran"] == nil {
                              chrTran = ""
                         }else{
                              chrTran = Tourplan_Daily[k]["chrTran"].stringValue
                         }
                         
                         if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                              continue
                         }
                         
                         
                         var intGlCode:Int = 0
                         if Tourplan_Daily[k]["intGlCode"] == nil {
                              intGlCode = 0
                         }else{
                              intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                         }
                         
                         
                         
                         
                         
                         var varType:String = ""
                         if Tourplan_Daily[k]["varType"] == nil {
                              varType = ""
                         }else{
                              varType = Tourplan_Daily[k]["varType"].stringValue
                         }
                         
                         var fk_From_CustomerGlCode:Int = 0
                         if Tourplan_Daily[k]["fk_From_CustomerGlCode"] == nil {
                              fk_From_CustomerGlCode = 0
                         }else{
                              fk_From_CustomerGlCode = Tourplan_Daily[k]["fk_From_CustomerGlCode"].intValue
                         }
                         
                         var fk_To_CustomerGlCode:Int = 0
                         if Tourplan_Daily[k]["fk_To_CustomerGlCode"] == nil {
                              fk_To_CustomerGlCode = 0
                         }else{
                              fk_To_CustomerGlCode = Tourplan_Daily[k]["fk_To_CustomerGlCode"].intValue
                         }
                         
                         
                         
                         var chrActive:String = ""
                         if Tourplan_Daily[k]["chrActive"] == nil {
                              chrActive = ""
                         }else{
                              chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                         }
                         
                         var dtEntryDate:String = ""
                         if Tourplan_Daily[k]["dtEntryDate"] == nil {
                              dtEntryDate = ""
                         }else{
                              dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                         }
                         
                         var ref_Entry_By:Int = 0
                         if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                              ref_Entry_By = 0
                         }else{
                              ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].intValue
                         }
                         
                         //dtModifiedDate
                         var dtModifiedDate:String = ""
                         if Tourplan_Daily[k]["dtModifiedDate"] == nil {
                              dtModifiedDate = ""
                         }else{
                              dtModifiedDate = Tourplan_Daily[k]["dtModifiedDate"].stringValue
                         }
                         
                         var ref_Modified_By:Int = 0
                         if Tourplan_Daily[k]["ref_Modified_By"] == nil {
                              ref_Modified_By = 0
                         }else{
                              ref_Modified_By = Tourplan_Daily[k]["ref_Modified_By"].intValue
                         }
                         
                         var chrSync:String = ""
                         if Tourplan_Daily[k]["chrSync"] == nil {
                              chrSync = ""
                         }else{
                              chrSync = Tourplan_Daily[k]["chrSync"].stringValue
                         }
                         
                         var dtSyncDate:String = ""
                         if Tourplan_Daily[k]["dtSyncDate"] == nil {
                              dtSyncDate = ""
                         }else{
                              dtSyncDate = Tourplan_Daily[k]["dtSyncDate"].stringValue
                         }
                         
                         var varSync_Code:String = ""
                         if Tourplan_Daily[k]["varSync_Code"] == nil {
                              varSync_Code = ""
                         }else{
                              varSync_Code = Tourplan_Daily[k]["varSync_Code"].stringValue
                         }
                         
                         let deleteQuery = "DELETE FROM Customer_Partner_Mst WHERE varSync_Code IN ('\(varSync_Code)')"
                         database.executeUpdate(deleteQuery, withArgumentsIn: [])
                         print("delete from sticker details-----------")
                         
                         
                         try database.executeUpdate("insert into Customer_Partner_Mst ( intGlCode,varType,fk_From_CustomerGlCode,fk_To_CustomerGlCode,chrActive,dtEntryDate,ref_Entry_By,dtModifiedDate,chrSync,dtSyncDate,varSync_Code) values (?,?,?,?,?,?,?,?)", values: [intGlCode,varType,fk_From_CustomerGlCode,fk_To_CustomerGlCode,chrActive,dtEntryDate,ref_Entry_By,dtModifiedDate,chrSync,dtSyncDate,varSync_Code])
                         //}
                         
                         k += 1
                    }
               }catch{
                    print("error Customer_Partner_Mst")
                    
                    return false
               }
               
               return true
          }
          
          return false
          //}
     }
     
     static func parseJsonCPM_PSKU_Batch_Stock(Tourplan_Daily:JSON,database: FMDatabase)->Bool{
          //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
          if(Tourplan_Daily.count > 0){
               do{
                    var k = 0
                    while (k < Tourplan_Daily.count){
                         
                         
                         
                         
                         var intGlCode:Int = 0
                         if Tourplan_Daily[k]["intGlCode"] == nil {
                              intGlCode = 0
                         }else{
                              intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                         }
                         
                         
                         
                         var fk_Customer_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Customer_GlCode"] == nil {
                              fk_Customer_GlCode = 0
                         }else{
                              fk_Customer_GlCode = Tourplan_Daily[k]["fk_Customer_GlCode"].intValue
                         }
                         
                         var fk_Product_SKU_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Product_SKU_GlCode"] == nil {
                              fk_Product_SKU_GlCode = 0
                         }else{
                              fk_Product_SKU_GlCode = Tourplan_Daily[k]["fk_Product_SKU_GlCode"].intValue
                         }
                         
                         var fk_UOM_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_UOM_GlCode"] == nil {
                              fk_UOM_GlCode = 0
                         }else{
                              fk_UOM_GlCode = Tourplan_Daily[k]["fk_UOM_GlCode"].intValue
                         }
                         
                         var varBatchNo:String = ""
                         if Tourplan_Daily[k]["varBatchNo"] == nil {
                              varBatchNo = ""
                         }else{
                              varBatchNo = Tourplan_Daily[k]["varBatchNo"].stringValue
                         }
                         
                         var dtExpiryDate:String = ""
                         if Tourplan_Daily[k]["dtExpiryDate"] == nil {
                              dtExpiryDate = ""
                         }else{
                              dtExpiryDate = Tourplan_Daily[k]["dtExpiryDate"].stringValue
                         }
                         
                         var decQty:Double = 0
                         if Tourplan_Daily[k]["decQty"] == nil {
                              decQty = 0
                         }else{
                              decQty = Tourplan_Daily[k]["decQty"].doubleValue
                         }
                         
                         var dtEntryDate:String = ""
                         if Tourplan_Daily[k]["dtEntryDate"] == nil {
                              dtEntryDate = ""
                         }else{
                              dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                         }
                         
                         
                         try database.executeUpdate("insert into CPM_PSKU_Batch_Stock ( intGlCode,fk_Customer_GlCode,fk_Product_SKU_GlCode,fk_UOM_GlCode,varBatchNo,dtExpiryDate,decQty,dtEntryDate) values (?,?,?,?,?,?,?,?)", values: [intGlCode,fk_Customer_GlCode,fk_Product_SKU_GlCode,fk_UOM_GlCode,varBatchNo,dtExpiryDate,decQty,dtEntryDate])
                         //}
                         
                         k += 1
                    }
               }catch{
                    print("error CPM_PSKU_Batch_Stock")
                    
                    return false
               }
               
               return true
          }
          
          return false
          //}
     }
     
    
     static func parseJsonCountries_Mst(Tourplan_Daily:JSON,database: FMDatabase)->Bool{
          //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
          if(Tourplan_Daily.count > 0){
               do{
                    var k = 0
                    while (k < Tourplan_Daily.count){
                         
                         
                         
                         
                         var intGlCode:Int = 0
                         if Tourplan_Daily[k]["intGlCode"] == nil {
                              intGlCode = 0
                         }else{
                              intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                         }
                         
                         var varCode:String = ""
                         if Tourplan_Daily[k]["varCode"] == nil {
                              varCode = ""
                         }else{
                              varCode = Tourplan_Daily[k]["varCode"].stringValue
                         }
                         
                         var varName:String = ""
                         if Tourplan_Daily[k]["varName"] == nil {
                              varName = ""
                         }else{
                              varName = Tourplan_Daily[k]["varName"].stringValue
                         }
                         
                         var varTime_Zone:String = ""
                         if Tourplan_Daily[k]["varTime_Zone"] == nil {
                              varTime_Zone = ""
                         }else{
                              varTime_Zone = Tourplan_Daily[k]["varTime_Zone"].stringValue
                         }
                         
                         var intUTC_Minute_Diff:String = ""
                         if Tourplan_Daily[k]["intUTC_Minute_Diff"] == nil {
                              intUTC_Minute_Diff = ""
                         }else{
                              intUTC_Minute_Diff = Tourplan_Daily[k]["intUTC_Minute_Diff"].stringValue
                         }
                         
                         var varLatitude:String = ""
                         if Tourplan_Daily[k]["varLatitude"] == nil {
                              varLatitude = ""
                         }else{
                              varLatitude = Tourplan_Daily[k]["varLatitude"].stringValue
                         }
                         
                         var varLongitude:String = ""
                         if Tourplan_Daily[k]["varLongitude"] == nil {
                              varLongitude = ""
                         }else{
                              varLongitude = Tourplan_Daily[k]["varLongitude"].stringValue
                         }
                         
                         var intFinancial_Month:Int = 0
                         if Tourplan_Daily[k]["intFinancial_Month"] == nil {
                              intFinancial_Month = 0
                         }else{
                              intFinancial_Month = Tourplan_Daily[k]["intFinancial_Month"].intValue
                         }
                         
                         var chrActive:String = ""
                         if Tourplan_Daily[k]["chrActive"] == nil {
                              chrActive = ""
                         }else{
                              chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                         }
                         
                         var dtEntryDate:String = ""
                         if Tourplan_Daily[k]["dtEntryDate"] == nil {
                              dtEntryDate = ""
                         }else{
                              dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                         }
                         
                         var ref_Entry_By:String = ""
                         if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                              ref_Entry_By = ""
                         }else{
                              ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].stringValue
                         }
                         
                         
                         /*let deleteQuery = "DELETE FROM CPM_Sticker_Details WHERE varSync_Code IN ('\(varSync_Code)')"
                          self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                          print("delete from sticker details-----------")*/
                         
                         try database.executeUpdate("insert into Countries_Mst ( intGlCode,varCode,varName,varName,varTime_Zone,intUTC_Minute_Diff,varLatitude,varLongitude,intFinancial_Month,chrActive,dtEntryDate,ref_Entry_By) values (?,?,?,?,?,?,?,?,?,?,?,?)", values: [intGlCode,varCode,varName,varName,varTime_Zone,intUTC_Minute_Diff,varLatitude,varLongitude,intFinancial_Month,chrActive,dtEntryDate,ref_Entry_By])
                         //}
                         
                         k += 1
                    }
               }catch{
                    print("error Countries_Mst")
                    
                    return false
               }
               
               return true
          }
          
          return false
          //}
     }
     
     static func parseJsonCPM_Customer_Dispatch(Tourplan_Daily:JSON,database: FMDatabase)->Bool{
          //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
          if(Tourplan_Daily.count > 0){
               do{
                    var k = 0
                    while (k < Tourplan_Daily.count){
                         
                         var chrTran:String = ""
                         if Tourplan_Daily[k]["chrTran"] == nil {
                              chrTran = ""
                         }else{
                              chrTran = Tourplan_Daily[k]["chrTran"].stringValue
                         }
                         
                         if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                              continue
                         }
                         
                         
                         var intGlCode:Int = 0
                         if Tourplan_Daily[k]["intGlCode"] == nil {
                              intGlCode = 0
                         }else{
                              intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                         }
                         
                         var fk_Customer_From_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Customer_From_GlCode"] == nil {
                              fk_Customer_From_GlCode = 0
                         }else{
                              fk_Customer_From_GlCode = Tourplan_Daily[k]["fk_Customer_From_GlCode"].intValue
                         }
                         
                         var fk_Customer_From_Type_CountryGlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Customer_From_Type_CountryGlCode"] == nil {
                              fk_Customer_From_Type_CountryGlCode = 0
                         }else{
                              fk_Customer_From_Type_CountryGlCode = Tourplan_Daily[k]["fk_Customer_From_Type_CountryGlCode"].intValue
                         }
                         
                         var fk_Customer_To_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Customer_To_GlCode"] == nil {
                              fk_Customer_To_GlCode = 0
                         }else{
                              fk_Customer_To_GlCode = Tourplan_Daily[k]["fk_Customer_To_GlCode"].intValue
                         }
                         
                         var fk_Customer_To_Type_CountryGlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Customer_To_Type_CountryGlCode"] == nil {
                              fk_Customer_To_Type_CountryGlCode = 0
                         }else{
                              fk_Customer_To_Type_CountryGlCode = Tourplan_Daily[k]["fk_Customer_To_Type_CountryGlCode"].intValue
                         }
                         
                         var fk_Sold_To_Party_GlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Sold_To_Party_GlCode"] == nil {
                              fk_Sold_To_Party_GlCode = 0
                         }else{
                              fk_Sold_To_Party_GlCode = Tourplan_Daily[k]["fk_Sold_To_Party_GlCode"].intValue
                         }
                         
                         var fk_Sold_To_Party_Type_CountryGlCode:Int = 0
                         if Tourplan_Daily[k]["fk_Sold_To_Party_Type_CountryGlCode"] == nil {
                              fk_Sold_To_Party_Type_CountryGlCode = 0
                         }else{
                              fk_Sold_To_Party_Type_CountryGlCode = Tourplan_Daily[k]["fk_Sold_To_Party_Type_CountryGlCode"].intValue
                         }
                         
                         var chrTransType:String = ""
                         if Tourplan_Daily[k]["chrTransType"] == nil {
                              chrTransType = ""
                         }else{
                              chrTransType = Tourplan_Daily[k]["chrTransType"].stringValue
                         }
                         
                         var chrExternal_Customer:String = ""
                         if Tourplan_Daily[k]["chrExternal_Customer"] == nil {
                              chrExternal_Customer = ""
                         }else{
                              chrExternal_Customer = Tourplan_Daily[k]["chrExternal_Customer"].stringValue
                         }
                         
                         var varCustomer_Name:String = ""
                         if Tourplan_Daily[k]["varCustomer_Name"] == nil {
                              varCustomer_Name = ""
                         }else{
                              varCustomer_Name = Tourplan_Daily[k]["varCustomer_Name"].stringValue
                         }
                         
                         var varEmail:String = ""
                         if Tourplan_Daily[k]["varEmail"] == nil {
                              varEmail = ""
                         }else{
                              varEmail = Tourplan_Daily[k]["varEmail"].stringValue
                         }
                         
                         var varMobile:String = ""
                         if Tourplan_Daily[k]["varMobile"] == nil {
                              varMobile = ""
                         }else{
                              varMobile = Tourplan_Daily[k]["varMobile"].stringValue
                         }
                         
                         var varPhone_No:String = ""
                         if Tourplan_Daily[k]["varPhone_No"] == nil {
                              varPhone_No = ""
                         }else{
                              varPhone_No = Tourplan_Daily[k]["varPhone_No"].stringValue
                         }
                         
                         var dtDispatchDate:String = ""
                         if Tourplan_Daily[k]["dtDispatchDate"] == nil {
                              dtDispatchDate = ""
                         }else{
                              dtDispatchDate = Tourplan_Daily[k]["dtDispatchDate"].stringValue
                         }
                         
                         var varSONO:String = ""
                         if Tourplan_Daily[k]["varSONO"] == nil {
                              varSONO = ""
                         }else{
                              varSONO = Tourplan_Daily[k]["varSONO"].stringValue
                         }
                         
                         var varDONO:String = ""
                         if Tourplan_Daily[k]["varDONO"] == nil {
                              varDONO = ""
                         }else{
                              varDONO = Tourplan_Daily[k]["varDONO"].stringValue
                         }
                         
                         var chrValidSave:String = ""
                         if Tourplan_Daily[k]["chrValidSave"] == nil {
                              chrValidSave = ""
                         }else{
                              chrValidSave = Tourplan_Daily[k]["chrValidSave"].stringValue
                         }
                         
                         var chrEditDO:String = ""
                         if Tourplan_Daily[k]["chrEditDO"] == nil {
                              chrEditDO = ""
                         }else{
                              chrEditDO = Tourplan_Daily[k]["chrEditDO"].stringValue
                         }
                         
                         var fk_EditDOBy:Int = 0
                         if Tourplan_Daily[k]["fk_EditDOBy"] == nil {
                              fk_EditDOBy = 0
                         }else{
                              fk_EditDOBy = Tourplan_Daily[k]["fk_EditDOBy"].intValue
                         }
                         
                         var dtEditDODate:String = ""
                         if Tourplan_Daily[k]["dtEditDODate"] == nil {
                              dtEditDODate = ""
                         }else{
                              dtEditDODate = Tourplan_Daily[k]["dtEditDODate"].stringValue
                         }
                         
                         var chrCancelDO:String = ""
                         if Tourplan_Daily[k]["chrCancelDO"] == nil {
                              chrCancelDO = ""
                         }else{
                              chrCancelDO = Tourplan_Daily[k]["chrCancelDO"].stringValue
                         }
                         
                         var fk_CancelDOBy:String = ""
                         if Tourplan_Daily[k]["fk_CancelDOBy"] == nil {
                              fk_CancelDOBy = ""
                         }else{
                              fk_CancelDOBy = Tourplan_Daily[k]["fk_CancelDOBy"].stringValue
                         }
                         
                         var dtCancelDODate:String = ""
                         if Tourplan_Daily[k]["dtCancelDODate"] == nil {
                              dtCancelDODate = ""
                         }else{
                              dtCancelDODate = Tourplan_Daily[k]["dtCancelDODate"].stringValue
                         }
                         var chrActive:String = ""
                         if Tourplan_Daily[k]["chrActive"] == nil {
                              chrActive = ""
                         }else{
                              chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                         }
                         var chrCompleted:String = ""
                         if Tourplan_Daily[k]["chrCompleted"] == nil {
                              chrCompleted = ""
                         }else{
                              chrCompleted = Tourplan_Daily[k]["chrCompleted"].stringValue
                         }
                         
                         var dtCompletedDate:String = ""
                         if Tourplan_Daily[k]["dtCompletedDate"] == nil {
                              dtCompletedDate = ""
                         }else{
                              dtCompletedDate = Tourplan_Daily[k]["dtCompletedDate"].stringValue
                         }
                         var chrSync:String = ""
                         if Tourplan_Daily[k]["chrSync"] == nil {
                              chrSync = ""
                         }else{
                              chrSync = Tourplan_Daily[k]["chrSync"].stringValue
                         }
                         
                         var varSync_Code:String = ""
                         if Tourplan_Daily[k]["varSync_Code"] == nil {
                              varSync_Code = ""
                         }else{
                              varSync_Code = Tourplan_Daily[k]["varSync_Code"].stringValue
                         }
                         
                         var dtSyncDate:String = ""
                         if Tourplan_Daily[k]["dtSyncDate"] == nil {
                              dtSyncDate = ""
                         }else{
                              dtSyncDate = Tourplan_Daily[k]["dtSyncDate"].stringValue
                         }
                         
                         var dtEntryDate:String = ""
                         if Tourplan_Daily[k]["dtEntryDate"] == nil {
                              dtEntryDate = ""
                         }else{
                              dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                         }
                         
                         var ref_Entry_By:String = ""
                         if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                              ref_Entry_By = ""
                         }else{
                              ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].stringValue
                         }
                         
                         var dtModifiedDate:String = ""
                         if Tourplan_Daily[k]["dtModifiedDate"] == nil {
                              dtModifiedDate = ""
                         }else{
                              dtModifiedDate = Tourplan_Daily[k]["dtModifiedDate"].stringValue
                         }
                         
                         var ref_Modified_By:Int = 0
                         if Tourplan_Daily[k]["ref_Modified_By"] == nil {
                              ref_Modified_By = 0
                         }else{
                              ref_Modified_By = Tourplan_Daily[k]["ref_Modified_By"].intValue
                         }
                         
                         
                         
                         let deleteQuery = "DELETE FROM CPM_Customer_Dispatch WHERE varSync_Code IN ('\(varSync_Code)')"
                         database.executeUpdate(deleteQuery, withArgumentsIn: [])
                         print("delete from CPM_Customer_Dispatch-----------")
                         
                         
                         
                         try database.executeUpdate("insert into CPM_Customer_Dispatch ( intGlCode,fk_Customer_From_GlCode,fk_Customer_From_Type_CountryGlCode,fk_Customer_To_GlCode,fk_Customer_To_Type_CountryGlCode,fk_Sold_To_Party_GlCode,fk_Sold_To_Party_Type_CountryGlCode,chrTransType,chrExternal_Customer,varCustomer_Name,varEmail,varMobile,varPhone_No,dtDispatchDate,varSONO,varDONO,chrValidSave,chrEditDO,fk_EditDOBy,dtEditDODate,chrCancelDO,fk_CancelDOBy,dtCancelDODate,chrActive,chrCompleted,dtCompletedDate,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", values: [intGlCode,fk_Customer_From_GlCode,fk_Customer_From_Type_CountryGlCode,fk_Customer_To_GlCode,fk_Customer_To_Type_CountryGlCode,fk_Sold_To_Party_GlCode,fk_Sold_To_Party_Type_CountryGlCode,chrTransType,chrExternal_Customer,varCustomer_Name,varEmail,varMobile,varPhone_No,dtDispatchDate,varSONO,varDONO,chrValidSave,chrEditDO,fk_EditDOBy,dtEditDODate,chrCancelDO,fk_CancelDOBy,dtCancelDODate,chrActive,chrCompleted,dtCompletedDate,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By])
                         //}
                         
                         k += 1
                    }
               }catch{
                    print("error CPM_Customer_Dispatch")
                    
                    return false
               }
               
               return true
          }
          
          return false
          //}
     }
     
     static func parseJsonStickerDetails(Tourplan_Daily:JSON,database: FMDatabase)->Bool{
          //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
          if(Tourplan_Daily.count > 0){
               do{
                    var k = 0
                    while (k < Tourplan_Daily.count){
                         let chrTran = Tourplan_Daily[k]["chrTran"].stringValue
                         
                         if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                              continue
                         }
                         
                         let intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                         let fk_StickerGlCode = Tourplan_Daily[k]["fk_StickerGlCode"].intValue
                         let varRef_Id = Tourplan_Daily[k]["varRef_Id"].stringValue
                         let varSystem_Name = Tourplan_Daily[k]["varSystem_Name"].stringValue
                         let fk_CustomerGlCode = Tourplan_Daily[k]["fk_CustomerGlCode"].intValue
                         let fk_CountryGlCode = Tourplan_Daily[k]["fk_CountryGlCode"].intValue
                         let fk_PBGGlCode = Tourplan_Daily[k]["fk_PBGGlCode"].intValue
                         let fk_PRDGlCode = Tourplan_Daily[k]["fk_PRDGlCode"].intValue
                         var fk_Product_SKUGlCode : Int = 0
                         
                         
                         if Tourplan_Daily[k]["fk_Product_SKUGlCode"] == nil {
                              fk_Product_SKUGlCode = 0
                         }else{
                              fk_Product_SKUGlCode = Tourplan_Daily[k]["fk_Product_SKUGlCode"].intValue
                         }
                         
                         
                         let varStickerType = Tourplan_Daily[k]["varStickerType"].stringValue
                         let varDINo = Tourplan_Daily[k]["varDINo"].stringValue
                         let varBatch_No = Tourplan_Daily[k]["varBatch_No"].stringValue
                         
                         var dtMFGDate:String = ""
                         if Tourplan_Daily[k]["dtMFGDate"] == nil {
                              dtMFGDate = ""
                         }else{
                              dtMFGDate = Tourplan_Daily[k]["dtMFGDate"].stringValue
                         }
                         
                         let dtExpireDate = Tourplan_Daily[k]["dtExpireDate"].stringValue
                         let varSticker_From_Range = Tourplan_Daily[k]["varSticker_From_Range"].stringValue
                         let varSticker_To_Range = Tourplan_Daily[k]["varSticker_To_Range"].stringValue
                         let varBTC_No_In = Tourplan_Daily[k]["varBTC_No_In"].stringValue
                         let varBTC_No_Out = Tourplan_Daily[k]["varBTC_No_Out"].stringValue
                         let varQR_Code_In = Tourplan_Daily[k]["varQR_Code_In"].stringValue
                         let varQR_Code_Out = Tourplan_Daily[k]["varQR_Code_Out"].stringValue
                         
                         let varSticker_No = Tourplan_Daily[k]["varSticker_No"].stringValue
                         let fk_StatusGlCode = Tourplan_Daily[k]["fk_StatusGlCode"].intValue
                         let fk_Sticker_GeneratedBy = Tourplan_Daily[k]["fk_Sticker_GeneratedBy"].intValue
                         let dtSticker_GeneratedDate = Tourplan_Daily[k]["dtSticker_GeneratedDate"].stringValue
                         
                         var chrExternal_Customer:String = ""
                         if Tourplan_Daily[k]["chrExternal_Customer"] == nil {
                              chrExternal_Customer = ""
                         }else{
                              chrExternal_Customer = Tourplan_Daily[k]["chrExternal_Customer"].stringValue
                         }
                         
                         let fk_Last_DispatchedBy = Tourplan_Daily[k]["fk_Last_DispatchedBy"].intValue
                         let fk_Last_PreviousDispatchBy = Tourplan_Daily[k]["fk_Last_PreviousDispatchBy"].intValue
                         let fk_Last_DispatchedTo = Tourplan_Daily[k]["fk_Last_DispatchedTo"].intValue
                         
                         let dtLast_DispatchedDate = Tourplan_Daily[k]["dtLast_DispatchedDate"].stringValue
                         let fk_Last_ReceivedBy = Tourplan_Daily[k]["fk_Last_ReceivedBy"].intValue
                         
                         var dtLast_RejectedDate:String = ""
                         if Tourplan_Daily[k]["dtLast_RejectedDate"] == nil {
                              dtLast_RejectedDate = ""
                         }else{
                              dtLast_RejectedDate = Tourplan_Daily[k]["dtLast_RejectedDate"].stringValue
                         }
                         
                         var chrDamage:String = ""
                         if Tourplan_Daily[k]["chrDamage"] == nil {
                              chrDamage = ""
                         }else{
                              chrDamage = Tourplan_Daily[k]["chrDamage"].stringValue
                         }
                         
                         var dtDamageDateTime:String = ""
                         if Tourplan_Daily[k]["dtDamageDateTime"] == nil {
                              dtDamageDateTime = ""
                         }else{
                              dtDamageDateTime = Tourplan_Daily[k]["dtDamageDateTime"].stringValue
                         }
                         
                         let fk_DamageBy = Tourplan_Daily[k]["fk_DamageBy"].intValue
                         
                         var chrActive:String = ""
                         if Tourplan_Daily[k]["chrActive"] == nil {
                              chrActive = ""
                         }else{
                              chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                         }
                         
                         var chrSync:String = ""
                         if Tourplan_Daily[k]["chrSync"] == nil {
                              chrSync = ""
                         }else{
                              chrSync = Tourplan_Daily[k]["chrSync"].stringValue
                         }
                         
                         var varSync_Code:String = ""
                         if Tourplan_Daily[k]["varSync_Code"] == nil {
                              varSync_Code = ""
                         }else{
                              varSync_Code = Tourplan_Daily[k]["varSync_Code"].stringValue
                         }
                         
                         var dtSyncDate:String = ""
                         if Tourplan_Daily[k]["dtSyncDate"] == nil {
                              dtSyncDate = ""
                         }else{
                              dtSyncDate = Tourplan_Daily[k]["dtSyncDate"].stringValue
                         }
                         
                         var dtEntryDate:String = ""
                         if Tourplan_Daily[k]["dtEntryDate"] == nil {
                              dtEntryDate = ""
                         }else{
                              dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                         }
                         
                         var ref_Entry_By:Int = 0
                         if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                              ref_Entry_By = 0
                         }else{
                              ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].intValue
                         }
                         
                         
                         var intPrintQty:Int = 0
                         if Tourplan_Daily[k]["intPrintQty"] == nil {
                              intPrintQty = 0
                         }else{
                              intPrintQty = Tourplan_Daily[k]["intPrintQty"].intValue
                         }
                         
                         var dtModifiedDate:String = ""
                         if Tourplan_Daily[k]["dtModifiedDate"] == nil {
                              dtModifiedDate = ""
                         }else{
                              dtModifiedDate = Tourplan_Daily[k]["dtModifiedDate"].stringValue
                         }
                         
                         var ref_Modified_By:Int = 0
                         if Tourplan_Daily[k]["ref_Modified_By"] == nil {
                              ref_Modified_By = 0
                         }else{
                              ref_Modified_By = Tourplan_Daily[k]["ref_Modified_By"].intValue
                         }
                         
                         var fk_Last_RejectedBy:Int = 0
                         if Tourplan_Daily[k]["fk_Last_RejectedBy"] == nil {
                              ref_Modified_By = 0
                         }else{
                              fk_Last_RejectedBy = Tourplan_Daily[k]["fk_Last_RejectedBy"].intValue
                         }
                         
                         
                         
                         var varLastStage:String = ""
                         if Tourplan_Daily[k]["varLastStage"] == nil {
                              varLastStage = ""
                         }else{
                              varLastStage = Tourplan_Daily[k]["varLastStage"].stringValue
                         }
                         
                         var dtLast_ReceivedDate:String = ""
                         if Tourplan_Daily[k]["dtLast_ReceivedDate"] == nil {
                              dtLast_ReceivedDate = ""
                         }else{
                              dtLast_ReceivedDate = Tourplan_Daily[k]["dtLast_ReceivedDate"].stringValue
                         }
                         
                         
                         let deleteQuery = "DELETE FROM CPM_Sticker_Details WHERE varSync_Code IN ('\(varSync_Code)')"
                         database.executeUpdate(deleteQuery, withArgumentsIn: [])
                         print("delete from sticker details-----------")
                         
                         try database.executeUpdate("insert into CPM_Sticker_Details ( fk_StickerGlCode,varRef_Id,varSystem_Name,fk_CustomerGlCode,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varStickerType,varDINo,varBatch_No,dtMFGDate,dtExpireDate,intPrintQty,varSticker_From_Range,varSticker_To_Range,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,chrExternal_Customer,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,fk_Last_DispatchedTo,dtLast_DispatchedDate,fk_Last_ReceivedBy,dtLast_ReceivedDate,fk_Last_RejectedBy,dtLast_RejectedDate,chrDamage,dtDamageDateTime,fk_DamageBy,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", values: [fk_StickerGlCode,varRef_Id,varSystem_Name,fk_CustomerGlCode,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varStickerType,varDINo,varBatch_No,dtMFGDate,dtExpireDate,intPrintQty,varSticker_From_Range,varSticker_To_Range,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,chrExternal_Customer,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,fk_Last_DispatchedTo,dtLast_DispatchedDate,fk_Last_ReceivedBy,dtLast_ReceivedDate,fk_Last_RejectedBy,dtLast_RejectedDate,chrDamage,dtDamageDateTime,fk_DamageBy,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage])
                         //}
                         
                         k += 1
                    }
               }catch{
                    print("error Tourplan_Daily")
                    
                    return false
               }
               
               return true
          }
          
          return false
          //}
     }
     
}
