package ecp.vcs.com.ecpsyncplugin;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;

import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Environment;
import android.os.StrictMode;
import android.provider.Settings;

import androidx.annotation.NonNull;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import android.util.Log;

import com.android.volley.DefaultRetryPolicy;
import com.android.volley.NetworkResponse;
import com.android.volley.Request;
import com.android.volley.RequestTickle;

import com.android.volley.request.StringRequest;
import com.android.volley.toolbox.VolleyTickle;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import java.util.Random;

import android.util.Base64;
import android.view.View;
import android.view.inputmethod.InputMethodManager;


//import net.sqlcipher.database.SQLiteDatabase;

import ecp.vcs.com.ecpsyncplugin.barcode.barcodereader.BarcodeCaptureActivity;
import ecp.vcs.com.ecpsyncplugin.filesync.AppIdentifyService;
import ecp.vcs.com.ecpsyncplugin.filesync.FileSyncCallBack;
import ecp.vcs.com.ecpsyncplugin.filesync.FileSyncTask;
import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry;

// ssc
// vcs@1234567

// wh_i
// Vcs@1234567

/**
 * EcpSyncPlugin
 */
public class EcpSyncPluginDPatel implements MethodCallHandler, EventChannel.StreamHandler {
    /**
     * Plugin registration.
     *//*
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "ecp_sync_plugin");
    channel.setMethodCallHandler(new EcpSyncPlugin());
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else {
      result.notImplemented();
    }
  }*/

    private static final String ECTERNAL_STORAGE_ROOT = "" + Environment
            .getExternalStorageDirectory();

    private static final String ECTERNAL_STORAGE_APP_ROOT = "" + ECTERNAL_STORAGE_ROOT + "/" +
            "Flut12er02app19/com.vcs.ecp";
    //public static final String ECTERNAL_STORAGE_APP_ROOT1 = "" + ECTERNAL_STORAGE_ROOT +
    //  "/ECP_Screenshots";
    //public static final String ECTERNAL_STORAGE_APP_ROOT_MULTI = "" + ECTERNAL_STORAGE_ROOT + "/" +
    //   ".Ev380p01k12cP16/com.vcs.ecp_multi";
    private static final String ECTERNAL_STORAGE_APP_SYNC_ROOT = "" + ECTERNAL_STORAGE_APP_ROOT +
            "/SyncBackup";
    private static final String ECTERNAL_STORAGE_APP_DOWNLOAD = "" +
            ECTERNAL_STORAGE_APP_SYNC_ROOT + "/Download";
    private static final String ECTERNAL_STORAGE_APP_UPLOAD = "" + ECTERNAL_STORAGE_APP_SYNC_ROOT
            + "/Upload";

    // --Commented out by Inspection (03/04/19, 2:41 PM):private static boolean isFielCopeError = false;
    // --Commented out by Inspection (03/04/19, 2:41 PM):private static String fileCopeException = "";
    private static String URLDownloadDB = "";
    private static String responseMsg = "";


    private static final String update_progress = "update_progress";
    private static final int REQUEST_ID_MULTIPLE_PERMISSIONS = 1;

    private final BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            Log.e("BroadCast", " onRecieve"); //do something with intent
            if (intent.getExtras() != null) {
                String SCAN = intent.getExtras().getString("SCAN");
                String JSONDATA = intent.getExtras().getString("JSONDATA");
                assert SCAN != null;
                if (SCAN.equalsIgnoreCase("done")) {
                    Log.e("BroadCast", "JSONDATA:" + JSONDATA);
                    sendBroadCastDetails(11, JSONDATA, 0);
                    registrar.activity().unregisterReceiver(mReceiver);
                } else {
                    sendBroadCastDetails(12, JSONDATA, 0);
                    registrar.activity().unregisterReceiver(mReceiver);
                }
            }
        }
    };

    public static void registerWith(final PluginRegistry.Registrar registrar) {
        final MethodChannel methodChannel =
                new MethodChannel(registrar.messenger(), "ecp_sync_plugin");
        final EventChannel eventChannel =
                new EventChannel(registrar.messenger(), "ecp_sync_plugin_Progress");
        final EcpSyncPluginDPatel instance = new EcpSyncPluginDPatel(registrar);
        eventChannel.setStreamHandler(instance);
        methodChannel.setMethodCallHandler(instance);

        registrar.addRequestPermissionsResultListener(new PluginRegistry.RequestPermissionsResultListener() {
            @Override
            public boolean onRequestPermissionsResult(int i, String[] strings, int[] ints) {
                return detailsPermission(i, strings, ints, registrar.activity());
            }
        });


    }

    private EcpSyncPluginDPatel(PluginRegistry.Registrar registrar) {
        this.registrar = registrar;


    }

    private final PluginRegistry.Registrar registrar;
    private BroadcastReceiver chargingStateChangeReceiver;

    private Context getActiveContext() {
        return (registrar.activity() != null) ? registrar.activity() : registrar.context();
    }

    //private int batteryLevel = -1;
    private String fk_EmpGlCode = "";
    private String ClientName = "";
    private String imei = "";
    private String version = "";
    private String UserName = "";
    private String urlUpload = "";
    private String logUploadMethod = "";
    private int syncID = 0;

    @Override
    public void onMethodCall(MethodCall call, Result result) {
        //Context context = getActiveContext();

        /*if (call.method.equals("getBatteryLevel")) {
            //int batteryLevel = getBatteryLevel();
            //int batteryLevel = -1;

            *//*if (batteryLevel != -1) {
                result.success(batteryLevel);
            } else {
                result.error("UNAVAILABLE", "Battery level not available.", null);
            }*//*
        } else*/ if (call.method.equals("hideKeyboardPlugin")) {
            //int batteryLevel = getBatteryLevel();
            //int batteryLevel = -1;

            //if (batteryLevel != -1) {
            try {
                View view = registrar.activity().getCurrentFocus();
                if (view != null) {
                    InputMethodManager imm = (InputMethodManager) registrar.activity()
                            .getSystemService(Context.INPUT_METHOD_SERVICE);
                    imm.hideSoftInputFromWindow(view.getWindowToken(), 0);
                }
                result.success("done");
            } catch (Exception e) {
                e.printStackTrace();
            }
            //} else {
            //result.error("UNAVAILABLE", "Battery level not available.", null);
            //}
        } else if (call.method.equals("restorePreferences")) {

            //flutter.deviceID //DeviceID
//flutter.NotificationToken //regId
//flutter.password //pref_password
//flutter.fkPoliticalGeoGICode //fk_Political_GeoGlCode
//flutter.userName //varUserID
//flutter.OrganizationName //varOrganizationName
//flutter.dateFormat //??
//flutter.isNotification //pref_is_notification_enable
//flutter.fkEmployeeTypeGICode //fk_Employee_TypeGlCode
//flutter.initGICode //intGlCode
//flutter.APIToken //varAPIToken
//flutter.isIntoScreen //INTRO_SLIDER_STATE
//flutter.fkCountryGICode //fk_CountryGlCode
//flutter.NotificationCount //??
//flutter.lastSyncDate //??
//flutter.RememberMe //pref_is_remember_me
//flutter.ReceiveCount //??
//flutter.dateTimeFormat //DATE_FORMAT
//flutter.mainCustomerGICode //MAIN_CUSTOMER_GL_CODE
//flutter.UserID //pref_user_name
//flutter.agreementURL //TERMS_CONDITION
//flutter.serverName //varServerName
//flutter.fkCustomerTypeCountryGICode //fk_Customer_Type_CountryGlCode
//flutter.timeFormat //TIME_FORMAT
//flutter.charGendar //??
//flutter.userType //chrUserType
//flutter.fullName //varFullName
//flutter.fkEmployeeDesignationCountryGlCode //fk_Employee_Designation_CountryGlCode
//flutter.isLogin //pref_is_login

            SharedPreferences mSharedPreferences = registrar.activity().getSharedPreferences("YRTJHGJHFGGDGCJ", Context.MODE_PRIVATE);
            String OrganizationName = mSharedPreferences.getString("varOrganizationName", "");
            String TERMS_CONDITION = mSharedPreferences.getString("TERMS_CONDITION", "");
            String DeviceID = mSharedPreferences.getString("DeviceID", "");
            String NotificationToken = mSharedPreferences.getString("regId", "");
            String password = mSharedPreferences.getString("pref_password", "");
            String userName = mSharedPreferences.getString("varUserID", "");
            String APIToken = mSharedPreferences.getString("varAPIToken", "");
            String dateTimeFormat = mSharedPreferences.getString("DATE_FORMAT", "");
            String UserID = mSharedPreferences.getString("pref_user_name", "");
            String agreementURL = mSharedPreferences.getString("TERMS_CONDITION", "");
            String serverName = mSharedPreferences.getString("varServerName", "");
            String timeFormat = mSharedPreferences.getString("TIME_FORMAT", "");
            String userType = mSharedPreferences.getString("chrUserType", "");
            String fullName = mSharedPreferences.getString("varFullName", "");


            int fkPoliticalGeoGICode = mSharedPreferences.getInt("fk_Political_GeoGlCode", 0);
            int fkEmployeeTypeGICode = mSharedPreferences.getInt("fk_Employee_TypeGlCode", 0);
            int initGICode = mSharedPreferences.getInt("intGlCode", 0);
            int fkCountryGICode = mSharedPreferences.getInt("fk_CountryGlCode", 0);
            int mainCustomerGICode = mSharedPreferences.getInt("MAIN_CUSTOMER_GL_CODE", 0);
            int fkCustomerTypeCountryGICode = mSharedPreferences.getInt("fk_Customer_Type_CountryGlCode", 0);
            int fkEmployeeDesignationCountryGlCode = mSharedPreferences.getInt("fk_Employee_Designation_CountryGlCode", 0);


            boolean isNotification = mSharedPreferences.getBoolean("pref_is_notification_enable", false);
            boolean isIntoScreen = mSharedPreferences.getBoolean("INTRO_SLIDER_STATE", false);
            boolean RememberMe = mSharedPreferences.getBoolean("pref_is_remember_me", false);
            boolean isLogin = mSharedPreferences.getBoolean("pref_is_login", false);

            try {
                JSONObject map = new JSONObject();
                map.put("OrganizationName", OrganizationName);
                map.put("TERMS_CONDITION", TERMS_CONDITION);
                map.put("DeviceID", DeviceID);
                map.put("NotificationToken", NotificationToken);
                map.put("password", password);
                map.put("userName", userName);
                map.put("APIToken", APIToken);
                map.put("dateTimeFormat", dateTimeFormat);
                map.put("UserID", UserID);
                map.put("agreementURL", agreementURL);
                map.put("serverName", serverName);
                map.put("timeFormat", timeFormat);
                map.put("userType", userType);
                map.put("fullName", fullName);
                map.put("fkPoliticalGeoGICode", fkPoliticalGeoGICode);
                map.put("fkEmployeeTypeGICode", fkEmployeeTypeGICode);
                map.put("initGICode", initGICode);
                map.put("fkCountryGICode", fkCountryGICode);
                map.put("mainCustomerGICode", mainCustomerGICode);
                map.put("fkCustomerTypeCountryGICode", fkCustomerTypeCountryGICode);
                map.put("fkEmployeeDesignationCountryGlCode", fkEmployeeDesignationCountryGlCode);

                map.put("isNotification", isNotification);
                map.put("isIntoScreen", isIntoScreen);
                map.put("RememberMe", RememberMe);
                map.put("isLogin", isLogin);

                //JSONArray jsonArray = new JSONArray();
                //jsonArray.put(map);
                Log.e("jsonArray:", "" + map.toString());
                result.success(map.toString());
            } catch (Exception e) {
                e.printStackTrace();
                result.success("notdone");
            }


        } else if (call.method.equals("checkSqliteChiper")) {

            /*try {

                String androidDBPath = call.argument("androidDBPath");
                String flutterDBPath = call.argument("flutterDBPath");
                Log.e("androidDBPath", "" + androidDBPath);
                Log.e("flutterDBPath", "" + flutterDBPath);

                if (new File(androidDBPath).exists()) {
                    SQLiteDatabase.loadLibs(registrar.activity());
                    ExportSqlChiper exportSqlChiper = new ExportSqlChiper();
                    boolean isEncripted = exportSqlChiper.checkDatabaseEnciptedorPlain(registrar.activity(), androidDBPath, "Vcs@1234");
                    if (isEncripted) {
                        exportSqlChiper.migratePlainTextDB(registrar.activity(), androidDBPath, "Vcs@1234");
                        Log.e("found encripted", "found encripted");
                        Utils.copyFile(new File(androidDBPath), new File(flutterDBPath));
                        Log.e("found encripted", "found encripted copy done");
                        Thread.sleep(2000);
                        Utils.deleteFiles(new File(androidDBPath));
                        Thread.sleep(1000);
                        result.success("done");
                    } else {
                        Log.e("not encripted", "not encripted");
                        result.success("notEncripted");
                    }
                } else {
                    result.success("AndroidNotFound");
                }
            } catch (Exception e) {
                e.printStackTrace();
                result.success("CRASH");
            }*/

        } else if (call.method.equalsIgnoreCase("syncronizeData")) {
            if (checkAndRequestPermissions(registrar.activity())) {
                if (call.hasArgument("UserName")) {
                    String _UserName = call.argument("UserName");
                    String _fk_EmpGlCode = call.argument("fk_EmpGlCode");
                    String _ClientName = call.argument("ClientName");
                    String _imei = call.argument("imei");
                    String _version = call.argument("version");
                    String packageName = call.argument("packageName");
                    String _logUploadMethod = call.argument("uploadMethod");
                    String _urlUpload = call.argument("urlUpload");
                    String databaseName = call.argument("databaseName");
                    String dbPassword = call.argument("dbPassword");
                    String isDbEncripted = call.argument("isDbEncripted");
                    String methodSyncID = call.argument("methodSyncID");
                    Log.e("syncronizeData:", "params:" + UserName);

                    UserName = _UserName;
                    fk_EmpGlCode = _fk_EmpGlCode;
                    ClientName = _ClientName;
                    imei = _imei;
                    version = _version;
                    urlUpload = _urlUpload;
                    logUploadMethod = methodSyncID;

                    if (_UserName != null && !_UserName.isEmpty()) {
                        new LongOperation().execute(_UserName, _fk_EmpGlCode, _ClientName, _imei, _version, packageName, _logUploadMethod, _urlUpload, databaseName, dbPassword, isDbEncripted);
                    } else {
                        result.error("UNAVAILABLE", "Perameters not available.", null);
                    }
                } else {
                    result.error("UNAVAILABLE", "Perameters not available.", null);
                }
            }
        } else if (call.method.equalsIgnoreCase("encodeData")) {
            if (call.hasArgument("details") && call.hasArgument("key")) {
                String details = call.argument("details");
                String key = call.argument("key");
                try {

                    try {
                        String encStr;
                        if (key != null) {
                            encStr = encriptionDetails.Encrypt(details, key);
                            result.success(encStr);
                        }

                    } catch (Exception e) {
                        e.printStackTrace();
                        result.error("UNAVAILABLE", "-" + e.getMessage(), null);
                    }

                    result.success("done");
                } catch (Exception e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                    result.success("error:" + e.getMessage());
                }

            } else {
                result.error("UNAVAILABLE", "perameters not found", null);
            }
        } else if (call.method.equalsIgnoreCase("decodeData")) {
            if (call.hasArgument("details") && call.hasArgument("key")) {
                String details = call.argument("details");
                String key = call.argument("key");

                try {
                    assert key != null;
                    String encStr = encriptionDetails.Decrypt(details, key);
                    result.success(encStr);
                } catch (Exception e) {
                    e.printStackTrace();
                    result.error("UNAVAILABLE", "-" + e.getMessage(), null);
                }

            } else {
                result.error("UNAVAILABLE", "perameters not found", null);
            }
        } else if (call.method.equalsIgnoreCase("UniqueNumber")) {

            try {
                String encStr = encriptionDetails.getUniqueNumber(registrar.context());
                result.success(encStr);
            } catch (Exception e) {
                e.printStackTrace();
                result.error("UNAVAILABLE", "-" + e.getMessage(), null);
            }

        } else if (call.method.equalsIgnoreCase("scanBarCodes")) {
            Log.e("scanBarCodes", "scanBarCodes");
            if (checkAndRequestPermissions(registrar.activity())) {

                registrar.activity().registerReceiver(mReceiver, new IntentFilter("ScanResult"));

                String isGoogleVision = call.argument("isGoogleVision");
                String isSingleScan = call.argument("isSingleScan");
                String isPlaySound = call.argument("isPlaySound");
                String isOnFlase = call.argument("isOnFlase");
                String themeColor = call.argument("themeColor");

                if (isGoogleVision.equalsIgnoreCase("false")) {
                    Intent i = new Intent(registrar.activity(), CameraBasfActivity.class);
                    i.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    i.putExtra("isSingleScan", isSingleScan);
                    i.putExtra("isPlaySound", isPlaySound);
                    i.putExtra("isOnFlase", isOnFlase);
                    i.putExtra("themeColor", themeColor);
                    registrar.context().startActivity(i);
                    result.success("done");
                } else {
                    //zydus check
                    Intent intent = new Intent(registrar.activity(), BarcodeCaptureActivity.class);
                    intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//                    intent.putExtra(AbstractCaptureActivity.AUTO_FOCUS, true);
//                    intent.putExtra(AbstractCaptureActivity.USE_FLASH, false);
//                    intent.putExtra(AbstractCaptureActivity.FORMATS, Barcode.ALL_FORMATS);
//                    intent.putExtra(AbstractCaptureActivity.MULTIPLE, false);
//                    intent.putExtra(AbstractCaptureActivity.WAIT_TAP, false);
//                    intent.putExtra(AbstractCaptureActivity.SHOW_TEXT, false);
//                    intent.putExtra(AbstractCaptureActivity.PREVIEW_WIDTH, 640);
//                    intent.putExtra(AbstractCaptureActivity.PREVIEW_HEIGHT, 480);
//                    intent.putExtra(AbstractCaptureActivity.CAMERA, CameraSource.CAMERA_FACING_BACK);
//                    intent.putExtra(AbstractCaptureActivity.FPS, 15.0f);
                    intent.putExtra(BarcodeCaptureActivity.AutoFocus, true);
                    intent.putExtra("isSingleScan", isSingleScan);
                    intent.putExtra("isPlaySound", isPlaySound);
                    intent.putExtra("isOnFlase", isOnFlase);
                    intent.putExtra("themeColor", themeColor);
                    registrar.context().startActivity(intent);
                    result.success("done");
                    //BarcodeCaptureActivity
                }
            }
        } else if (call.method.equalsIgnoreCase("checkPermission")) {
            Log.e("checkPermission", "checkPermission");
            if (checkAndRequestPermissions(registrar.activity())) {
                result.success("true");
            } else {
                result.success("false");
            }
        } else if (call.method.equalsIgnoreCase("getTimeFromUTC")) {
            String date = call.argument("date");
            String format = call.argument("format");
            try {
                String dt = Utils.getTimeFromUTC(date, format);
                result.success(dt);
            } catch (Exception e) {
                e.printStackTrace();
                result.success("error");
            }
        } else if (call.method.equalsIgnoreCase("syncronizeDataFile")) {
            if (checkWriteExternalPermission()) {
                if (call.hasArgument("UserName")) {
                    String UserName = call.argument("UserName");
                    String fk_EmpGlCode = call.argument("fk_EmpGlCode");
                    String ClientName = call.argument("ClientName");
                    String imei = call.argument("imei");
                    String version = call.argument("version");
                    String packageName = call.argument("packageName");
                    String uploadMethod = call.argument("uploadMethod");
                    String logUploadMethod = call.argument("logUploadMethod");
                    String urlUpload = call.argument("urlUpload");
                    String databaseName = call.argument("databaseName");
                    Log.e("syncronizeDataFile:", "params:" + UserName);
                    String dbPassword = call.argument("dbPassword");
                    String isDbEncripted = call.argument("isDbEncripted");

                    if (UserName != null && !UserName.isEmpty()) {
                        // Added by Sagar
                        FileSyncTask fileSyncTask = new FileSyncTask(getActiveContext(), fileSyncCallBack, UserName, fk_EmpGlCode, ClientName, imei, version, packageName, uploadMethod, logUploadMethod, urlUpload, databaseName, dbPassword, isDbEncripted);
                        fileSyncTask.execute();
                    } else {
                        result.error("UNAVAILABLE", "Perameters not available.", null);
                    }
                } else {
                    result.error("UNAVAILABLE", "Perameters not available.", null);
                }
            } else {
                sendBroadCastDetails(2, "storage permission not granted", lastProgress);
                result.error("UNAVAILABLE", "storage permission not granted", null);
            }
        } else if (call.method.equalsIgnoreCase("checkInternet")) {
//            boolean isNet = isNetworkConnected(registrar.context()) && hasActiveInternetConnection();
            boolean isNet = isNetworkConnected(registrar.context());
            if (isNet) result.success("true");
            else result.success("false");
        } else if (call.method.equalsIgnoreCase("checkBarCode")) {
            String code = call.argument("code");
            assert code != null;
            String finalCode = Utils.getSerialNoFromBarcode(code, true);
            result.success(finalCode);
        } else {
            result.notImplemented();
        }
    }

    private boolean isNetworkConnected(Context context) {
        ConnectivityManager cm =
                (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
        return activeNetwork != null &&
                activeNetwork.isConnectedOrConnecting();
    }

    private boolean hasActiveInternetConnection() {
        boolean issend;
        if (android.os.Build.VERSION.SDK_INT <= 27) {
            StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll()
                    .build();
            StrictMode.setThreadPolicy(policy);
            //}
            try {
                URL url = new URL("http://www.google.com");
                HttpURLConnection urlc = (HttpURLConnection) (url.openConnection());
                urlc.setRequestProperty("User-Agent", "Test");
                urlc.setRequestProperty("Connection", "close");
                urlc.setConnectTimeout(1500);
                urlc.connect();
                Log.e("Utils", "Active internet connection");
                issend = (urlc.getResponseCode() == 200);
            } catch (IOException e) {
                Log.e("Utils ret false", "Error checking internet connection", e);
                issend = false;
            }
            return issend;
        } else {
            return true;
        }
    }

    @Override
    public void onListen(Object arguments, EventChannel.EventSink events) {
        Log.e("BroadCast", "onListen");
        chargingStateChangeReceiver = createChargingStateChangeReceiver(events);
        registrar
                .context()
                .registerReceiver(
                        chargingStateChangeReceiver, new IntentFilter(update_progress));
    }

    @Override
    public void onCancel(Object arguments) {
        Log.e("BroadCast", "onCancel");
        registrar.context().unregisterReceiver(chargingStateChangeReceiver);
        chargingStateChangeReceiver = null;
    }


    /*private int getBatteryLevel() {
        int batteryLevel = -1;
        Context context = registrar.context();
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            BatteryManager batteryManager =
                    (BatteryManager) context.getSystemService(context.BATTERY_SERVICE);
            batteryLevel = batteryManager.getIntProperty(BatteryManager.BATTERY_PROPERTY_CAPACITY);
        } else {
            Intent intent =
                    new ContextWrapper(context)
                            .registerReceiver(null, new IntentFilter(Intent.ACTION_BATTERY_CHANGED));
            batteryLevel =
                    (intent.getIntExtra(BatteryManager.EXTRA_LEVEL, -1) * 100)
                            / intent.getIntExtra(BatteryManager.EXTRA_SCALE, -1);
        }

        return batteryLevel;
    }*/

    private class LongOperation extends AsyncTask<String, Void, String> {

        @Override
        protected String doInBackground(String... params) {

            /*if (params[10].equalsIgnoreCase("true")) {
                try {
                    ExportSqlChiper exportSqlChiper = new ExportSqlChiper();
                    String dataDirPath = Environment.getDataDirectory() + "/data/" + params[5] + "/app_flutter/" + params[8];
                    Log.e("dataDirPath ", "plain text:" + dataDirPath);
                    if (exportSqlChiper.checkDatabaseEnciptedorPlain(registrar.context(), dataDirPath, "Vcs@1234")) {
                        Thread.sleep(500);
                        exportSqlChiper.migratePlainTextDB(registrar.context(), dataDirPath, "Vcs@1234");
                    }
                    Thread.sleep(2000);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }*/

            String doneItem = SyncDB(params[0], params[1], params[2], params[3], params[4], params[5], params[6], params[7], params[8], registrar.context(), params[9], params[10]);
            //return "";
            if(!doneItem.equalsIgnoreCase("done")){
                responseMsg = doneItem;
            }

            if (doneItem.equalsIgnoreCase("done")) {
                startIntentService("Y");
            } else {
                startIntentService("N");
            }

            return doneItem;
        }

        @Override
        protected void onPostExecute(String result) {
            if (result != null && result.equalsIgnoreCase("done")) {
                sendBroadCastDetails(3, responseMsg, 100);
            } else {
                sendBroadCastDetails(2, result, lastProgress);
            }
        }

        @Override
        protected void onPreExecute() {
        }

        @Override
        protected void onProgressUpdate(Void... values) {
        }
    }

    private void sendBroadCastDetails(int type, String details, int progress) {
        //type = 1 => progress, 2 => errors, 3 => sync complate
        Log.e("sendBroadCastDetails", "sendBroadCastDetails");
        Intent intent = new Intent(update_progress);
        intent.putExtra("type", type);
        intent.putExtra("progress", progress);
        intent.putExtra("details", details);
        this.registrar.context().sendBroadcast(intent);
    }

    private BroadcastReceiver createChargingStateChangeReceiver(final EventChannel.EventSink events) {
        return new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                int type = intent.getIntExtra("type", -1);
                int progress = intent.getIntExtra("progress", -1);
                String Details = intent.getStringExtra("details");

                Map<String, String> parameterPost = new HashMap<>();
                parameterPost.clear();
                parameterPost.put("type", String.valueOf(type));
                parameterPost.put("progress", String.valueOf(progress));
                parameterPost.put("Details", Details);

                events.success(parameterPost);
            }
        };
    }

    private String SyncDB(String UserName, String fk_EmpGlCode, String ClientName, String imei, String
            strVersion, String packageName, String uploadMethod, String urlUpload, String DATABASE_NAME, Context context, String dbPassword, String isDbEncripted) {
        /*Log.e("UserName", ":" + UserName);
        Log.e("fk_EmpGlCode", ":" + fk_EmpGlCode);
        Log.e("ClientName", ":" + ClientName);
        Log.e("imei", ":" + imei);
        Log.e("strVersion", ":" + strVersion);
        Log.e("packageName", ":" + packageName);
        Log.e("uploadMethod", ":" + uploadMethod);
        Log.e("urlUpload", ":" + urlUpload);*/

        String tempName = Utils.GetCurrentDate("ddMMyyyy_HHmmss") + "_" + UserName;
        String fName = tempName + "_ecp_mobile.db";
        String fZipName = tempName + "_ecp_mobile.zip";
        String exportPath = ECTERNAL_STORAGE_APP_UPLOAD;
        Calendar calendar = Calendar.getInstance();
        int WDAY = calendar.get(Calendar.DAY_OF_WEEK);

        String dataDirPath = Environment.getDataDirectory() + "/data/" + packageName + "/app_flutter/" + DATABASE_NAME;

        sendBroadCastDetails(1, "export DB", randInt(1, 5));

        if (exportSyncDbNew(dataDirPath, exportPath, fName, WDAY)) {
            sendBroadCastDetails(1, "zip DB", randInt(5, 7));
            if (!Utils.CreateZipFile(exportPath, fName, fZipName, WDAY, dbPassword, isDbEncripted).equalsIgnoreCase("")) {
                sendBroadCastDetails(1, "upload DB", randInt(7, 15));
                //String downloadPath = ECTERNAL_STORAGE_APP_DOWNLOAD;
                //Log.e("strUploadMessage", ":" + strUploadMessage);
                return UploadDatabaseFileZipOld(urlUpload, fZipName, UserName,
                        fk_EmpGlCode, ClientName, imei, strVersion, context, WDAY, exportPath, uploadMethod, fName, DATABASE_NAME, dataDirPath, packageName, dbPassword, isDbEncripted);
            } else {
                sendBroadCastDetails(2, "Filed to create zip file", lastProgress);
                return "notdone";
            }
        } else {
            sendBroadCastDetails(2, "Export database filed", lastProgress);
            return "notdone";
        }
    }

    private static boolean SdIsPresent() {
        return Environment.getExternalStorageState().equals(
                Environment.MEDIA_MOUNTED);
    }

    private boolean exportSyncDbNew(String dataDirPath, String exportPath, String Filename, int Wday) {

        Log.e("dataDirPath", ":" + dataDirPath);
        Log.e("exportPath", ":" + exportPath);

        if (!SdIsPresent())
            return false;

        if (new File(dataDirPath).exists()) {
            File exportDir = new File(exportPath + "/" + Wday);
            if (!exportDir.exists()) {
                //noinspection ResultOfMethodCallIgnored
                exportDir.mkdirs();
            }
            File file = new File(exportDir, Filename);
            try {
                if (!file.exists()) {
                    //noinspection ResultOfMethodCallIgnored
                    file.createNewFile();
                    Utils.copyFile(new File(dataDirPath), file);
                    return true;
                } else {
                    return false;
                }
            } catch (IOException e) {
                //isFielCopeError = true;
                //fileCopeException = "101: " + Utils.checkErrorReset(Utils.ConvertExceptionToString(e));
                return false;
            }
        } else {
            //isFielCopeError = true;
            //fileCopeException = "101";
            return false;
        }
    }

    private String UploadDatabaseFileZipOld(String url, String strFilename, String UserName, String fk_EmpGlCode, String
            ClientName, String Imei, String strVersion, Context context, int WDAY, String uploadPath, String MNDatabaseUpload,
                                            String fName, String DATABASE_NAME, String dataDirPath, String packageName, String dbPassword, String isDbEncripted) {

        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);

        String strSyncMessage = "Done";

        try {
            byte[] fByte = Utils.ConvertDBFile(uploadPath, strFilename, context, WDAY);
            String encodeDb = "";
            if (fByte != null) {
                //encodeDb = Base64.encodeBytes(fByte);
                encodeDb = Base64.encodeToString(fByte, Base64.DEFAULT);
            }
            sendBroadCastDetails(1, "upload DB", randInt(15, 20));
            //changePercent(randInt(25, 27));

            if (fByte != null && !encodeDb.equalsIgnoreCase("")) {
                fByte = null;
                // changePercent(randInt(27, 30));

                sendBroadCastDetails(1, "upload DB", randInt(20, 25));

                //VolleyLog.DEBUG = true;

                final Map<String, String> parameterPost = new HashMap<>();
                parameterPost.clear();

                //ECP
                /*parameterPost.put("FileArray", encodeDb);
                parameterPost.put("Filename", strFilename);
                parameterPost.put("UserName", UserName);
                parameterPost.put("fk_EmpGLCode", String.valueOf(fk_EmpGlCode));
                parameterPost.put("varClientName", ClientName);
                parameterPost.put("varIMEINumber", Imei);
                parameterPost.put("strVersion", strVersion);
                parameterPost.put("varAppType", "Android");*/

                //BASF_HK
                parameterPost.put("FileArray", encodeDb);
                parameterPost.put("FileName", strFilename);
                parameterPost.put("DeviceId", Imei);
                parameterPost.put("PersonId", fk_EmpGlCode);
                parameterPost.put("Version", strVersion);
                parameterPost.put("SubModuleName", ClientName);
                parameterPost.put("APIToken", UserName);

                encodeDb = null;

                RequestTickle mRequestTickle = VolleyTickle.newRequestTickle(registrar.context());

                StringRequest stringRequest = new StringRequest(Request.Method.POST, url + "/" + MNDatabaseUpload, null,
                        null) {

                    protected Map<String, String> getParams() {
                        if (parameterPost.size() > 0) {
                            return parameterPost;
                        } else {
                            //Utils.printLoge(5, "noperameters jsonTask....", "............" + Utils.parameterPost);
                            return null;
                        }
                    }

                };
                //int DEFAULT_TIMEOUT_MS = 720000;
                int DEFAULT_TIMEOUT_MS = 2700000;
                //int DEFAULT_TIMEOUT_MS = 120000;
                stringRequest.setRetryPolicy(new DefaultRetryPolicy(
                        DEFAULT_TIMEOUT_MS,
                        DefaultRetryPolicy.DEFAULT_MAX_RETRIES,
                        DefaultRetryPolicy.DEFAULT_BACKOFF_MULT));
                mRequestTickle.add(stringRequest);
                NetworkResponse response = mRequestTickle.start();

                Log.e("jsonUploadDownloadDB", "-->" + response.statusCode);
                String jsonUploadDownloadDB;
                if (response.statusCode == 200) {
                    jsonUploadDownloadDB = VolleyTickle.parseResponse(response);


                    sendBroadCastDetails(1, "upload DB", randInt(26, 35));

                    Log.e("download ", "link : " + jsonUploadDownloadDB);
                    JSONObject json = new JSONObject(jsonUploadDownloadDB);
                    JSONArray jsonArray = json.optJSONArray("Status");
                    responseMsg = json.getString("Message");
                    if (jsonArray != null) {
                        int jsonSize = jsonArray.length();
                        for (int jsonIndex = 0; jsonIndex < jsonSize; jsonIndex++) {
                            JSONObject innerObject = jsonArray.getJSONObject(jsonIndex);
                            if (innerObject != null) {
                                String strValidSync = innerObject.optString("isValid");

                                sendBroadCastDetails(1, "upload DB", randInt(36, 40));

                                if (strValidSync.equalsIgnoreCase("True")) {
                                    URLDownloadDB = innerObject.optString("Message");
                                } else {
                                    strSyncMessage = innerObject.optString("Message");
                                }

                                strSyncMessage = afterUpload(strSyncMessage, strFilename, fName, DATABASE_NAME,
                                        dataDirPath, strVersion, packageName, dbPassword, isDbEncripted);
                            }
                        }
                    } else {
                        //strSyncMessage = "102";
                        String Status = json.getString("Status");
                        String Response = json.getString("Response");

                        if (Status.equalsIgnoreCase("1")) {
                            URLDownloadDB = Response;

                            strSyncMessage = afterUpload(strSyncMessage, strFilename, fName, DATABASE_NAME,
                                    dataDirPath, strVersion, packageName, dbPassword, isDbEncripted);
                        } else {
                            strSyncMessage = "102";
                        }
                    }

                    try {
                        String syncId = json.optString("SyncId");
                        syncID = syncId != null ? Integer.parseInt(syncId) : 0;
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                } else {
                    strSyncMessage = "102";
                }
            } else {
                strSyncMessage = "103";
            }
        } catch (Exception e) {

            e.printStackTrace();
            String error = e.getMessage();
            strSyncMessage = "104: " + error;
        }
        return strSyncMessage;
    }

    private String DownloadDBFromUrlZip(String DownloadUrl, String ZipfileName, String dbFilename, String databaseName, String zipPassword) {
        String strSyncMessage = "Done";
        try {
            File downloadDB = new File(EcpSyncPluginDPatel.ECTERNAL_STORAGE_APP_DOWNLOAD);
            if (!downloadDB.exists())
                //noinspection ResultOfMethodCallIgnored
                downloadDB.mkdirs();

            // changePercent(randInt(50, 60));
            sendBroadCastDetails(1, "upload DB", randInt(51, 60));
            File file = new File(EcpSyncPluginDPatel.ECTERNAL_STORAGE_APP_DOWNLOAD, ZipfileName);

            //final int BUFFER_SIZE = 32 * 1024;
            final int BUFFER_SIZE = 3 * 1024;
            URL url = new URL(DownloadUrl);

            URLConnection uCon = url.openConnection();
            //uCon.setConnectTimeout(120000);
            uCon.setConnectTimeout(2700000);
            InputStream downloadInputStream = uCon.getInputStream();
            //int fileLength = ucon.getContentLength();
            BufferedInputStream bufferedInputStream = new BufferedInputStream(downloadInputStream, BUFFER_SIZE);
            FileOutputStream fileOutputStream = new FileOutputStream(file);
            byte[] byteBuffer = new byte[BUFFER_SIZE];
            int current = 0;

            //changePercent(randInt(65, 70));
            sendBroadCastDetails(1, "upload DB", randInt(61, 70));

            while (current != -1) {
                fileOutputStream.write(byteBuffer, 0, current);
                current = bufferedInputStream.read(byteBuffer, 0, BUFFER_SIZE);
            }


            fileOutputStream.flush();
            fileOutputStream.close();
            downloadInputStream.close();


            //changePercent(randInt(71, 73));

            sendBroadCastDetails(1, "upload DB", randInt(71, 75));

        } catch (Exception e) {
            e.printStackTrace();
            String error = e.getMessage();
            error = Utils.checkErrorReset(error);
            strSyncMessage = "104: " + error;
        }

        //changePercent(randInt(74, 77));

        if (strSyncMessage.equals("Done")) {
            strSyncMessage = ExtractDownlodedFile(ZipfileName, dbFilename, strSyncMessage, databaseName, zipPassword);
        }
        return strSyncMessage;
    }

    private String ExtractDownlodedFile(String ZipfileName, String dbFilename, String strSyncMessage, String databaseName, String zipPassword) {

        String zipFile = EcpSyncPluginDPatel.ECTERNAL_STORAGE_APP_DOWNLOAD + "/" + ZipfileName;

        //String size = checkFileZiseString(zipFile);
        //data_createJson.put("9_DOWNLOAD_FILE_SIZE", "" + size);

        //DatabaseExportImport databaseExportImport = new DatabaseExportImport();

        if (!Utils.ExtractSingleFile(zipFile, "" + EcpSyncPluginDPatel.ECTERNAL_STORAGE_APP_DOWNLOAD + "/", dbFilename, zipPassword)
                .equalsIgnoreCase("Done")) {
            strSyncMessage = "105:";
        } else {
            try {

                sendBroadCastDetails(1, "upload DB", randInt(76, 82));
                //changePercent(randInt(78, 82));

                File f = new File("" + EcpSyncPluginDPatel.ECTERNAL_STORAGE_APP_DOWNLOAD + "/" + dbFilename);
                File f1 = new File("" + EcpSyncPluginDPatel.ECTERNAL_STORAGE_APP_DOWNLOAD + "/" + databaseName);
                if (f.exists()) {
                    if (f1.exists()) {
                        //noinspection ResultOfMethodCallIgnored
                        f1.delete();
                    }
                    //noinspection ResultOfMethodCallIgnored
                    f.renameTo(f1);
                }
            } catch (Exception e) {
                String error = e.getMessage();
                error = Utils.checkErrorReset(error);
                strSyncMessage = "104: " + error;
            }
        }

        return strSyncMessage;
    }

    private String afterUpload(String strUploadMessage, String fZipName, String fName, String databaseName, String dataDirPath, String version, String packageName, String dbPassword, String isDbEncripted) {
        //changePercent(randInt(20, 25));

        //DatabaseExportImport databaseExportImport = new DatabaseExportImport();


        if (strUploadMessage.equalsIgnoreCase("Done")) {

            // data_createJson.put("6_UPLOAD_END", "" + getTimeinSec(new DateTime()));
            sendBroadCastDetails(1, "upload DB", randInt(41, 45));
            // changePercent(randInt(40, 45));

            String DownloadURL = URLDownloadDB;
            //Utils.printLoge1(5, "CALL", "DownloadURL : " + SyncURLDownloadDB);
            if (DownloadURL.trim().length() > 0) {

                // data_createJson.put("7_DOWNLOAD_URL", DownloadURL);

                // changePercent(randInt(45, 50));

                sendBroadCastDetails(1, "upload DB", randInt(46, 50));

                // data_createJson.put("8_DOWNLOAD_START", "" + getTimeinSec(new DateTime()));

                String strDBMessage = DownloadDBFromUrlZip(DownloadURL, fZipName, fName, databaseName, dbPassword);//, context, databaseName

                if (strDBMessage.equals("Done")) {
                    //data_createJson.put("9_DOWNLOAD_END", "" + getTimeinSec(new DateTime()));

                    //changePercent(randInt(82, 90));

                    sendBroadCastDetails(1, "upload DB", randInt(83, 90));

                    try {
                        Thread.sleep(1000);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                    //data_createJson.put("10_RESTORE_DB_START", "" + getTimeinSec(new DateTime()));

                    //int restore = databaseExportImport.restoreDownloadedDb(NEW_APP_VERSION_SYNC, dataDirPath, downloadPath, databaseName);
                    int restore = 0;
                    if (!SdIsPresent())
                        restore = 1;

                    File exportFile = new File(dataDirPath);
                    File importFile = new File(EcpSyncPluginDPatel.ECTERNAL_STORAGE_APP_DOWNLOAD, databaseName);


                    if (!importFile.exists()) {
                        restore = 1;
                    }

                    Log.e("at::", "isDatabaseCorrupted");

                    /*if (checkCurrupDownload) {
                        Log.e("inside::", "isDatabaseCorrupted");
                        if (Utils.isDatabaseCorrupted(importFile.getAbsolutePath()))
                            restore = 5;
                    }*/

                    if (restore == 0) {

                        Log.e("delete::", "delete db from package");
                        //Dhaval Change: 05/06/18
                        try {
                            Thread.sleep(1000);
                            Utils.deleteFiles(exportFile);
                            Thread.sleep(3000);
                        } catch (Exception e) {
                            Log.e("error::", "delete file 1:" + e.getMessage());
                            e.printStackTrace();
                            try {
                                Thread.sleep(1000);
                                Utils.deleteFiles(exportFile);
                                Thread.sleep(3000);
                            } catch (Exception eq) {
                                Log.e("error::", "delete file 2:" + e.getMessage());
                                eq.printStackTrace();
                            }
                        }
                        Log.e("Copy::", "copy db start");
                        try {
                            Thread.sleep(1000);
                            try {
                                //noinspection ResultOfMethodCallIgnored
                                exportFile.createNewFile();
                            } catch (IOException eio) {
                                eio.printStackTrace();
                                //restore = 4;
                            }
                            Thread.sleep(2000);
                            boolean isCopy = Utils.copyDataBase(importFile, exportFile, version);
                            Thread.sleep(3000);
                            restore = isCopy ? 3 : 2;
                        } catch (Exception e) {
                            Log.e("error::", "copy file 1:" + e.getMessage());
                            e.printStackTrace();
                            //Dhaval change : 05/06/18
                            try {
                                Thread.sleep(2000);
                                boolean isCopy = Utils.copyDataBase(importFile, exportFile, version);
                                Thread.sleep(3000);
                                restore = isCopy ? 3 : 2;
                            } catch (Exception e1) {
                                Log.e("error::", "copy file 2:" + e.getMessage());
                                e1.printStackTrace();
                                //restore = 1;
                                try {
                                    Thread.sleep(2000);
                                    boolean isCopy = Utils.copyDataBase(importFile, exportFile, version);
                                    Thread.sleep(3000);
                                    restore = isCopy ? 3 : 2;
                                } catch (Exception e2) {
                                    Log.e("error::", "copy file 2:" + e.getMessage());
                                    e2.printStackTrace();
                                    restore = 1;
                                }
                            }
                        }


                        try {
                            Thread.sleep(3000);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }

                        Log.e("restore", "restore DB Return:" + restore);
                    }

                    if (restore == 3) {

                        //data_createJson.put("11_RESTORE_DB_END1", "" + getTimeinSec(new DateTime()));

                        //changePercent(randInt(90, 96));
                        //ECP_Scan_SyncSyncCompleteStatus = true;
                        sendBroadCastDetails(1, "upload DB", randInt(91, 96));

                        try {
                            Thread.sleep(1000);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }

                        //data_createJson.put("12_CHECK_DB_CURRUPT_START", "" + getTimeinSec(new DateTime()));
                        //boolean isCurrupt = Utils.isDatabaseCorruptedNew(ECPSyncronizationService.this, packageName);
                        //File importFile = new File(ECTERNAL_STORAGE_APP_DOWNLOAD, DbExportImport.DATABASE_NAME);

                        try {
                            Thread.sleep(2000);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }

                        /*if (isDbEncripted.equalsIgnoreCase("true")) {
                            try {
                                ExportSqlChiper exportSqlChiper = new ExportSqlChiper();
                                String dataDirPath1 = Environment.getDataDirectory() + "/data/" + packageName + "/app_flutter/" + databaseName;
                                Log.e("dataDirPath ", "plain text:" + dataDirPath1);
                                if (exportSqlChiper.checkDatabaseEnciptedorPlain(registrar.context(), dataDirPath1, "")) {
                                    Thread.sleep(500);
                                    exportSqlChiper.migrateEncriptedDB(registrar.context(), dataDirPath1, dbPassword);
                                }
                                Thread.sleep(2000);
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }*/


                        //sendBroadCastDetails(3, "Sync Complate 100%");
                        return "done";

                    } else {
                        if (restore == 2) {
                            //syncStageStatus = "F";
                            //data_createJson.put("10_RESTORE_DB_END_FAIL", "ERROR : 107" + getTimeinSec(new DateTime()));
                            // database currupted
                            //ECP_Scan_SyncSyncCompleteStatus = false;
                            //isFielCopeError = true;
                            //fileCopeException = "107";
                            //ECP_Scan_SyncSyncCompleteStatus = false;
                            //Utils.printLoge1(5, "CALL", "ERROR : 107");
                            sendBroadCastDetails(2, "10_RESTORE_DB_END_FAIL 107", lastProgress);
                            return "notdone";
                        } else if (restore == 5) {
                            // syncStageStatus = "F";
                            // data_createJson.put("10_RESTORE_DB_END_FAIL", "ERROR : 223" + getTimeinSec(new DateTime()));

                            // database currupted
                            // ECP_Scan_SyncSyncCompleteStatus = false;
                            //isFielCopeError = true;
                            //fileCopeException = "225";
                            //ECP_Scan_SyncSyncCompleteStatus = false;
                            //Utils.printLoge1(5, "CALL", "ERROR : 223");
                            sendBroadCastDetails(2, "10_RESTORE_DB_END_FAIL 223", lastProgress);
                            return "notdone";
                        } else {
                            // syncStageStatus = "F";
                            // data_createJson.put("10_RESTORE_DB_END_FAIL", "ERROR : 106" + getTimeinSec(new DateTime()));

                            // ECP_Scan_SyncSyncCompleteStatus = false;
                            //isFielCopeError = true;
                            //fileCopeException = "106";
                            // ECP_Scan_SyncSyncCompleteStatus = false;
                            sendBroadCastDetails(2, "10_RESTORE_DB_END_FAIL 106", lastProgress);
                            return "notdone";
                        }
                    }
                } else {

                    // syncStageStatus = "F";
                    // data_createJson.put("9_DOWNLOAD_END_FAIL", "ERROR : 106:2 :" + CommonFunctionLib.GetCurrentDate(ENTRY_DATE));

                    //isFielCopeError = true;
                    //fileCopeException = "106: " + Utils.checkErrorReset(strDBMessage);
                    //ECP_Scan_SyncSyncCompleteStatus = false;
                    sendBroadCastDetails(2, "9_DOWNLOAD_END_FAIL", lastProgress);
                    return "notdone";
                }
            } else {

                // syncStageStatus = "F";
                //   data_createJson.put("6_DOWNLOAD_END_FAIL", "ERROR : 106:3 :" + getTimeinSec(new DateTime()));

                //   ECP_Scan_SyncSyncCompleteStatus = false;
                sendBroadCastDetails(2, "6_DOWNLOAD_END_FAIL", lastProgress);
                return "notdone";
            }
        } else {

            // syncStageStatus = "F";
            // data_createJson.put("5_UPLOAD_END_FAIL", "ERROR : 101 : " + getTimeinSec(new DateTime()));

            //isFielCopeError = true;
            //fileCopeException = "101: " + Utils.checkErrorReset(strUploadMessage);
            // ECP_Scan_SyncSyncCompleteStatus = false;
            sendBroadCastDetails(2, "5_UPLOAD_END_FAIL", lastProgress);
            return "notdone";
        }

        //whenAllProgressDone();
    }

    private int lastProgress = 0;

    private int randInt(int min, int max) {

        // NOTE: This will (intentionally) not run as written so that folks
        // copy-pasting have to think about how to initialize their
        // Random instance.  Initialization of the Random instance is outside
        // the main scope of the question, but some decent options are to have
        // a field that is initialized once and then re-used as needed or to
        // use ThreadLocalRandom (if using at least Java 1.7).
        //
        // In particular, do NOT do 'Random rand = new Random()' here or you
        // will get not very good / not very random results.
        Random rand = new Random();
        // nextInt is normally exclusive of the top value,
        // so add 1 to make it inclusive
        lastProgress = rand.nextInt((max - min) + 1) + min;
        return lastProgress;
    }

    private boolean checkWriteExternalPermission() {
        String permission = android.Manifest.permission.WRITE_EXTERNAL_STORAGE;
        int res = registrar.context().checkCallingOrSelfPermission(permission);
        return (res == PackageManager.PERMISSION_GRANTED);
    }


    private static boolean checkAndRequestPermissions(Activity registrar) {
        if (Build.VERSION.SDK_INT >= 23) {
            int permissionStorage = ContextCompat.checkSelfPermission(registrar,
                    Manifest.permission.WRITE_EXTERNAL_STORAGE);
            // int locationPermission = ContextCompat.checkSelfPermission(registrar.activity(), Manifest.permission.ACCESS_FINE_LOCATION);
            int cameraPermission = ContextCompat.checkSelfPermission(registrar, Manifest.permission.CAMERA);
            //int contactsPermission = ContextCompat.checkSelfPermission(registrar, Manifest.permission.GET_ACCOUNTS);
            int callPhonePermission = ContextCompat.checkSelfPermission(registrar, Manifest.permission.READ_PHONE_STATE);
            //int receiveSMSPermission = ContextCompat.checkSelfPermission(registrar.activity(), Manifest.permission.RECEIVE_SMS);

            List<String> listPermissionsNeeded = new ArrayList<>();
            /*if (locationPermission != PackageManager.PERMISSION_GRANTED) {
                listPermissionsNeeded.add(Manifest.permission.ACCESS_FINE_LOCATION);
            }*/
            if (permissionStorage != PackageManager.PERMISSION_GRANTED) {
                listPermissionsNeeded.add(Manifest.permission.WRITE_EXTERNAL_STORAGE);
            }
            if (cameraPermission != PackageManager.PERMISSION_GRANTED) {
                listPermissionsNeeded.add(Manifest.permission.CAMERA);
            }
            //if (contactsPermission != PackageManager.PERMISSION_GRANTED) {
            // listPermissionsNeeded.add(Manifest.permission.GET_ACCOUNTS);
            //}
            if (callPhonePermission != PackageManager.PERMISSION_GRANTED) {
                listPermissionsNeeded.add(Manifest.permission.READ_PHONE_STATE);
            }
            /*if (receiveSMSPermission != PackageManager.PERMISSION_GRANTED) {
                listPermissionsNeeded.add(Manifest.permission.RECEIVE_SMS);
            }*/
            if (!listPermissionsNeeded.isEmpty()) {
                ActivityCompat.requestPermissions(registrar, listPermissionsNeeded.toArray(new String[0]), REQUEST_ID_MULTIPLE_PERMISSIONS);
                return false;
            }
        }
        return true;
    }

    /*@Override
    public void onRequestPermissionsResult(int requestCode,
                                           @NonNull String permissions[], @NonNull int[] grantResults) {
        String TAG = "Permission";
        Log.d(TAG, "Permission callback called-------");
        switch (requestCode) {
            case REQUEST_ID_MULTIPLE_PERMISSIONS: {
                Map<String, Integer> perms = new HashMap<>();
                // Initialize the map with both permissions
                perms.put(Manifest.permission.CAMERA, PackageManager.PERMISSION_GRANTED);
                perms.put(Manifest.permission.ACCESS_FINE_LOCATION, PackageManager.PERMISSION_GRANTED);
                perms.put(Manifest.permission.WRITE_EXTERNAL_STORAGE, PackageManager.PERMISSION_GRANTED);
                perms.put(Manifest.permission.READ_EXTERNAL_STORAGE, PackageManager.PERMISSION_GRANTED);
                perms.put(Manifest.permission.READ_PHONE_STATE, PackageManager.PERMISSION_GRANTED);
                perms.put(Manifest.permission.GET_ACCOUNTS, PackageManager.PERMISSION_GRANTED);
                perms.put(Manifest.permission.RECEIVE_SMS, PackageManager.PERMISSION_GRANTED);

                // Fill with actual results from user
                if (grantResults.length > 0) {
                    for (int i = 0; i < permissions.length; i++)
                        perms.put(permissions[i], grantResults[i]);
                    // Check for both permissions
                    if (perms.get(Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED
                            && perms.get(Manifest.permission.ACCESS_FINE_LOCATION) == PackageManager.PERMISSION_GRANTED
                            && perms.get(Manifest.permission.WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED
                            && perms.get(Manifest.permission.READ_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED
                            && perms.get(Manifest.permission.RECEIVE_SMS) == PackageManager.PERMISSION_GRANTED
                            && perms.get(Manifest.permission.GET_ACCOUNTS) == PackageManager.PERMISSION_GRANTED
                            && perms.get(Manifest.permission.READ_PHONE_STATE) == PackageManager.PERMISSION_GRANTED) {
                        Log.d(TAG, "All permission granted");
//                        init();
                    } else {
                        Log.d(TAG, "Some permissions are not granted ask again ");
                        if (ActivityCompat.shouldShowRequestPermissionRationale(this, Manifest.permission.CAMERA)
                                || ActivityCompat.shouldShowRequestPermissionRationale(this, Manifest.permission.ACCESS_FINE_LOCATION)
                                || ActivityCompat.shouldShowRequestPermissionRationale(this, Manifest.permission.READ_EXTERNAL_STORAGE)
                                || ActivityCompat.shouldShowRequestPermissionRationale(this, Manifest.permission.RECEIVE_SMS)
                                || ActivityCompat.shouldShowRequestPermissionRationale(this, Manifest.permission.WRITE_EXTERNAL_STORAGE)
                                || ActivityCompat.shouldShowRequestPermissionRationale(this, Manifest.permission.GET_ACCOUNTS)
                                || ActivityCompat.shouldShowRequestPermissionRationale(this, Manifest.permission.READ_PHONE_STATE)) {
//                            showAlertWithOkButtonCallback(1, "Some Permission required for use this app.");
                        } else {
                            showAlertWithOkButtonCallback(2, "Some permissions needed. Please allow in App Settings for additional functionality.");
                        }
                    }
                }
            }
        }
    }*/

    private static boolean detailsPermission(int requestCode, @NonNull String permissions[], @NonNull int[] grantResults, Activity context) {
        String TAG = "Permission";
        Log.d(TAG, "Permission callback called-------");
        if (requestCode == REQUEST_ID_MULTIPLE_PERMISSIONS) {
            //case REQUEST_ID_MULTIPLE_PERMISSIONS: {
            Map<String, Integer> perms = new HashMap<>();
            // Initialize the map with both permissions
            perms.put(Manifest.permission.CAMERA, PackageManager.PERMISSION_GRANTED);
            perms.put(Manifest.permission.WRITE_EXTERNAL_STORAGE, PackageManager.PERMISSION_GRANTED);
            perms.put(Manifest.permission.READ_PHONE_STATE, PackageManager.PERMISSION_GRANTED);
            //perms.put(Manifest.permission.GET_ACCOUNTS, PackageManager.PERMISSION_GRANTED);

            // Fill with actual results from user
            if (grantResults.length > 0) {
                for (int i = 0; i < permissions.length; i++)
                    perms.put(permissions[i], grantResults[i]);
                // Check for both permissions
                if (perms.get(Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED
                        && perms.get(Manifest.permission.WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED
                        //&& perms.get(Manifest.permission.GET_ACCOUNTS) == PackageManager.PERMISSION_GRANTED
                        && perms.get(Manifest.permission.READ_PHONE_STATE) == PackageManager.PERMISSION_GRANTED) {
                    Log.e(TAG, "All permission granted");
//                        init();
                    return true;

                } else {
                    Log.e(TAG, "Some permissions are not granted ask again ");
                    if (ActivityCompat.shouldShowRequestPermissionRationale(context, Manifest.permission.CAMERA)
                            || ActivityCompat.shouldShowRequestPermissionRationale(context, Manifest.permission.WRITE_EXTERNAL_STORAGE)
                            //|| ActivityCompat.shouldShowRequestPermissionRationale(context, Manifest.permission.GET_ACCOUNTS)
                            || ActivityCompat.shouldShowRequestPermissionRationale(context, Manifest.permission.READ_PHONE_STATE)) {
                        //showAlertWithOkButtonCallback(1, "Some Permission required for use this app.","");
                        Log.e(TAG, "Some Permission required for use this app.");
                        return false;
                    } else {
                        showAlertWithOkButtonCallback(2, "Some permissions needed. Please allow in App Settings for additional functionality.", "", context);
                        return false;
                    }
                }
            } else {
                return false;
            }
            //}
        } else {
            return false;
        }
    }

    private static void showAlertWithOkButtonCallback(final int type, String text, String app_name, final Activity activity) {

        AlertDialog.Builder builder =
                new AlertDialog.Builder(activity);
        builder.setTitle(app_name);
        builder.setMessage(text);
        builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                if (type == 1) {
                    checkAndRequestPermissions(activity);
                } else {
                    Intent intent = new Intent(Settings.ACTION_APPLICATION_DETAILS_SETTINGS,
                            Uri.fromParts("package", activity.getPackageName(), null));
                    intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    activity.startActivity(intent);
                }
            }
        });
        builder.setCancelable(false);
        builder.show();
    }

    // File Sync Code by Sagar Zala

    private final FileSyncCallBack fileSyncCallBack = new FileSyncCallBack() {
        @Override
        public void onFileSyncResponse(int type, String details, int progress) {
            sendBroadCastDetails(type, details, progress);
        }
    };

    /*private void migratePlainTextDB(Context context,String datbasePath, String Password) {
        //File dbFile = ctxt.getDatabasePath(".encryptedDb");
        //FeedReaderDbHelper.getInstance(this);

        try {
            File newFile = File.createTempFile("sqlcipherutils", "tmp", context.getCacheDir());
            File legacyFile = new File(datbasePath);
            if (legacyFile.exists()) {
                SQLiteDatabase db = SQLiteDatabase.openOrCreateDatabase(legacyFile, Password, null);

                db.rawExecSQL(String.format("ATTACH DATABASE '%s' AS plaintext KEY '%s';", newFile.getAbsolutePath(), ""));
                db.rawExecSQL("SELECT sqlcipher_export('plaintext')");
                db.rawExecSQL("DETACH DATABASE plaintext;");
                int version = db.getVersion();
                db.close();
                db = SQLiteDatabase.openDatabase(newFile.getAbsolutePath(), "", null, SQLiteDatabase.OPEN_READWRITE);
                db.setVersion(version);
                db.close();
                legacyFile.delete();
                newFile.renameTo(legacyFile);

                Thread.sleep(1000);

                if (!newFile.exists() && legacyFile.exists()) {
                    db = SQLiteDatabase.openDatabase(legacyFile.getAbsolutePath(), "", null, SQLiteDatabase.OPEN_READWRITE);
                    Cursor cursor = db.rawQuery("SELECT * FROM '" + FeedReaderContract.FeedEntry.TABLE_NAME + "';", null);
                    Log.e(MainActivity.class.getSimpleName(), "Rows count: " + cursor.getCount());
                    cursor.close();
                    db.close();
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }*/


    private void startIntentService(String status) {
        //Log.e("DB", "=========startIntentService called : =========" + status);
       /* appPrefs.setSyncId(syncID);
        appPrefs.setDeviceSyncStatus(status);
        appPrefs.setDeviceSyncJson(hashMap.toString());*/

        Intent vcsTimeIntent = new Intent(registrar.activity(), AppIdentifyService.class);
        vcsTimeIntent.putExtra("SyncId", syncID);
        vcsTimeIntent.putExtra("DeviceSyncStatus", status);
        vcsTimeIntent.putExtra("DeviceSyncJson", "");
        vcsTimeIntent.putExtra("PersonId", fk_EmpGlCode);
        vcsTimeIntent.putExtra("SubModuleName", ClientName);
        vcsTimeIntent.putExtra("DeviceId", imei);
        vcsTimeIntent.putExtra("Version", version);
        vcsTimeIntent.putExtra("APIToken", UserName);
        vcsTimeIntent.putExtra("BaseUrl", urlUpload);
        vcsTimeIntent.putExtra("logUploadMethod", logUploadMethod);

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            registrar.activity().startForegroundService(vcsTimeIntent);
        } else {
            registrar.activity().startService(vcsTimeIntent);
        }
    }

}
